/* Boxlib
(c) 2023 by Malte Marwedel

SPDX-License-Identifier:  BSD-3-Clause
*/

#include <stdint.h>
#include <stdbool.h>

#include "coprocMt.h"

#include "boxlib/coproc.h"
#include "FreeRTOS.h"
#include "semphr.h"

#define MUTEX_TIMEOUT 100

SemaphoreHandle_t g_coprocSemaphore;
StaticSemaphore_t g_coprocSemaphoreState;

void CoprocInitMt(void) {
	g_coprocSemaphore = xSemaphoreCreateMutexStatic(&g_coprocSemaphoreState);
	CoprocInit();
}

void CoprocLockMt(void) {
	//Simply must succeed
	while (xSemaphoreTake(g_coprocSemaphore, 1000) == pdFALSE);
}

void CoprocUnlockMt(void) {
	xSemaphoreGive(g_coprocSemaphore);
}
